// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
suite("test_index_rqg_bug8", "test_index_rqg_bug8"){
    def table1 = "test_index_rqg_bug8"

    sql "drop table if exists ${table1}"

    sql """
            CREATE TABLE ${table1} (
        `pk` int NULL,
        `col_int_undef_signed_index_inverted` int NULL,
        `col_boolean_undef_signed` boolean NULL,
        `col_boolean_undef_signed_not_null` boolean NOT NULL,
        `col_tinyint_undef_signed` tinyint NULL,
        `col_tinyint_undef_signed_index_inverted` tinyint NULL,
        `col_tinyint_undef_signed_not_null` tinyint NOT NULL,
        `col_tinyint_undef_signed_not_null_index_inverted` tinyint NOT NULL,
        `col_smallint_undef_signed` smallint NULL,
        `col_smallint_undef_signed_index_inverted` smallint NULL,
        `col_smallint_undef_signed_not_null` smallint NOT NULL,
        `col_smallint_undef_signed_not_null_index_inverted` smallint NOT NULL,
        `col_int_undef_signed` int NULL,
        `col_int_undef_signed_not_null` int NOT NULL,
        `col_int_undef_signed_not_null_index_inverted` int NOT NULL,
        `col_bigint_undef_signed` bigint NULL,
        `col_bigint_undef_signed_index_inverted` bigint NULL,
        `col_bigint_undef_signed_not_null` bigint NOT NULL,
        `col_bigint_undef_signed_not_null_index_inverted` bigint NOT NULL,
        `col_decimal_16__8__undef_signed` decimal(16,8) NULL,
        `col_decimal_16__8__undef_signed_index_inverted` decimal(16,8) NULL,
        `col_decimal_16__8__undef_signed_not_null` decimal(16,8) NOT NULL,
        `col_decimal_16__8__undef_signed_not_null_index_inverted` decimal(16,8) NOT NULL,
        `col_decimal_38__9__undef_signed` decimal(38,9) NULL,
        `col_decimal_38__9__undef_signed_index_inverted` decimal(38,9) NULL,
        `col_decimal_38__9__undef_signed_not_null` decimal(38,9) NOT NULL,
        `col_decimal_38__9__undef_signed_not_null_index_inverted` decimal(38,9) NOT NULL,
        `col_decimal_38__30__undef_signed` decimal(38,30) NULL,
        `col_decimal_38__30__undef_signed_index_inverted` decimal(38,30) NULL,
        `col_decimal_38__30__undef_signed_not_null` decimal(38,30) NOT NULL,
        `col_decimal_38__30__undef_signed_not_null_index_inverted` decimal(38,30) NOT NULL,
        `col_date_undef_signed` date NULL,
        `col_date_undef_signed_index_inverted` date NULL,
        `col_date_undef_signed_not_null` date NOT NULL,
        `col_date_undef_signed_not_null_index_inverted` date NOT NULL,
        `col_datetime_undef_signed` datetime NULL,
        `col_datetime_undef_signed_index_inverted` datetime NULL,
        `col_datetime_undef_signed_not_null` datetime NOT NULL,
        `col_datetime_undef_signed_not_null_index_inverted` datetime NOT NULL,
        `col_datetime_3__undef_signed` datetime(3) NULL,
        `col_datetime_3__undef_signed_index_inverted` datetime(3) NULL,
        `col_datetime_3__undef_signed_not_null` datetime(3) NOT NULL,
        `col_datetime_3__undef_signed_not_null_index_inverted` datetime(3) NOT NULL,
        `col_datetime_6__undef_signed` datetime(6) NULL,
        `col_datetime_6__undef_signed_index_inverted` datetime(6) NULL,
        `col_datetime_6__undef_signed_not_null` datetime(6) NOT NULL,
        `col_datetime_6__undef_signed_not_null_index_inverted` datetime(6) NOT NULL,
        `col_char_255__undef_signed` character(255) NULL,
        `col_char_255__undef_signed_index_inverted` character(255) NULL,
        `col_char_255__undef_signed_index_inverted_p_e` character(255) NULL,
        `col_char_255__undef_signed_index_inverted_p_u` character(255) NULL,
        `col_char_255__undef_signed_not_null` character(255) NOT NULL,
        `col_char_255__undef_signed_not_null_index_inverted` character(255) NOT NULL,
        `col_char_255__undef_signed_not_null_index_inverted_p_e` character(255) NOT NULL,
        `col_char_255__undef_signed_not_null_index_inverted_p_u` character(255) NOT NULL,
        `col_varchar_1024__undef_signed` varchar(1024) NULL,
        `col_varchar_1024__undef_signed_index_inverted` varchar(1024) NULL,
        `col_varchar_1024__undef_signed_index_inverted_p_e` varchar(1024) NULL,
        `col_varchar_1024__undef_signed_index_inverted_p_u` varchar(1024) NULL,
        `col_varchar_1024__undef_signed_not_null` varchar(1024) NOT NULL,
        `col_varchar_1024__undef_signed_not_null_index_inverted` varchar(1024) NOT NULL,
        `col_varchar_1024__undef_signed_not_null_index_inverted_p_e` varchar(1024) NOT NULL,
        `col_varchar_1024__undef_signed_not_null_index_inverted_p_u` varchar(1024) NOT NULL,
        INDEX col_tinyint_undef_signed_index_inverted_idx (`col_tinyint_undef_signed_index_inverted`) USING INVERTED,
        INDEX col_tinyint_undef_signed_not_null_index_inverted_idx (`col_tinyint_undef_signed_not_null_index_inverted`) USING INVERTED,
        INDEX col_smallint_undef_signed_index_inverted_idx (`col_smallint_undef_signed_index_inverted`) USING INVERTED,
        INDEX col_smallint_undef_signed_not_null_index_inverted_idx (`col_smallint_undef_signed_not_null_index_inverted`) USING INVERTED,
        INDEX col_int_undef_signed_index_inverted_idx (`col_int_undef_signed_index_inverted`) USING INVERTED,
        INDEX col_int_undef_signed_not_null_index_inverted_idx (`col_int_undef_signed_not_null_index_inverted`) USING INVERTED,
        INDEX col_bigint_undef_signed_index_inverted_idx (`col_bigint_undef_signed_index_inverted`) USING INVERTED,
        INDEX col_bigint_undef_signed_not_null_index_inverted_idx (`col_bigint_undef_signed_not_null_index_inverted`) USING INVERTED,
        INDEX col_decimal_16__8__undef_signed_index_inverted_idx (`col_decimal_16__8__undef_signed_index_inverted`) USING INVERTED,
        INDEX col_decimal_16__8__undef_signed_not_null_index_inverted_idx (`col_decimal_16__8__undef_signed_not_null_index_inverted`) USING INVERTED,
        INDEX col_decimal_38__9__undef_signed_index_inverted_idx (`col_decimal_38__9__undef_signed_index_inverted`) USING INVERTED,
        INDEX col_decimal_38__9__undef_signed_not_null_index_inverted_idx (`col_decimal_38__9__undef_signed_not_null_index_inverted`) USING INVERTED,
        INDEX col_decimal_38__30__undef_signed_index_inverted_idx (`col_decimal_38__30__undef_signed_index_inverted`) USING INVERTED,
        INDEX col_decimal_38__30__undef_signed_not_null_index_inverted_idx (`col_decimal_38__30__undef_signed_not_null_index_inverted`) USING INVERTED,
        INDEX col_date_undef_signed_index_inverted_idx (`col_date_undef_signed_index_inverted`) USING INVERTED,
        INDEX col_date_undef_signed_not_null_index_inverted_idx (`col_date_undef_signed_not_null_index_inverted`) USING INVERTED,
        INDEX col_datetime_undef_signed_index_inverted_idx (`col_datetime_undef_signed_index_inverted`) USING INVERTED,
        INDEX col_datetime_undef_signed_not_null_index_inverted_idx (`col_datetime_undef_signed_not_null_index_inverted`) USING INVERTED,
        INDEX col_datetime_3__undef_signed_index_inverted_idx (`col_datetime_3__undef_signed_index_inverted`) USING INVERTED,
        INDEX col_datetime_3__undef_signed_not_null_index_inverted_idx (`col_datetime_3__undef_signed_not_null_index_inverted`) USING INVERTED,
        INDEX col_datetime_6__undef_signed_index_inverted_idx (`col_datetime_6__undef_signed_index_inverted`) USING INVERTED,
        INDEX col_datetime_6__undef_signed_not_null_index_inverted_idx (`col_datetime_6__undef_signed_not_null_index_inverted`) USING INVERTED,
        INDEX col_char_255__undef_signed_index_inverted_idx (`col_char_255__undef_signed_index_inverted`) USING INVERTED,
        INDEX col_char_255__undef_signed_index_inverted_p_e_idx (`col_char_255__undef_signed_index_inverted_p_e`) USING INVERTED PROPERTIES("parser" = "english", "lower_case" = "true", "support_phrase" = "true"),
        INDEX col_char_255__undef_signed_index_inverted_p_u_idx (`col_char_255__undef_signed_index_inverted_p_u`) USING INVERTED PROPERTIES("parser" = "unicode", "lower_case" = "true", "support_phrase" = "true"),
        INDEX col_char_255__undef_signed_not_null_index_inverted_idx (`col_char_255__undef_signed_not_null_index_inverted`) USING INVERTED,
        INDEX col_char_255__undef_signed_not_null_index_inverted_p_e_idx (`col_char_255__undef_signed_not_null_index_inverted_p_e`) USING INVERTED PROPERTIES("parser" = "english", "lower_case" = "true", "support_phrase" = "true"),
        INDEX col_char_255__undef_signed_not_null_index_inverted_p_u_idx (`col_char_255__undef_signed_not_null_index_inverted_p_u`) USING INVERTED PROPERTIES("parser" = "unicode", "lower_case" = "true", "support_phrase" = "true"),
        INDEX col_varchar_1024__undef_signed_index_inverted_idx (`col_varchar_1024__undef_signed_index_inverted`) USING INVERTED,
        INDEX col_varchar_1024__undef_signed_index_inverted_p_e_idx (`col_varchar_1024__undef_signed_index_inverted_p_e`) USING INVERTED PROPERTIES("parser" = "english", "lower_case" = "true", "support_phrase" = "true"),
        INDEX col_varchar_1024__undef_signed_index_inverted_p_u_idx (`col_varchar_1024__undef_signed_index_inverted_p_u`) USING INVERTED PROPERTIES("parser" = "unicode", "lower_case" = "true", "support_phrase" = "true"),
        INDEX col_varchar_1024__undef_signed_not_null_index_inverted_idx (`col_varchar_1024__undef_signed_not_null_index_inverted`) USING INVERTED,
        INDEX col_varchar_1024__undef_signed_not_null_index_inverted_p_e_idx (`col_varchar_1024__undef_signed_not_null_index_inverted_p_e`) USING INVERTED PROPERTIES("parser" = "english", "lower_case" = "true", "support_phrase" = "true"),
        INDEX col_varchar_1024__undef_signed_not_null_index_inverted_p_u_idx (`col_varchar_1024__undef_signed_not_null_index_inverted_p_u`) USING INVERTED PROPERTIES("parser" = "unicode", "lower_case" = "true", "support_phrase" = "true")
        ) ENGINE=OLAP
        UNIQUE KEY(`pk`, `col_int_undef_signed_index_inverted`)
        DISTRIBUTED BY HASH(`pk`) BUCKETS 10
        PROPERTIES (
        "replication_allocation" = "tag.location.default: 1",
        "min_load_replica_num" = "-1",
        "bloom_filter_columns" = "col_varchar_1024__undef_signed, col_date_undef_signed_not_null, col_date_undef_signed, col_int_undef_signed, col_varchar_1024__undef_signed_not_null, col_int_undef_signed_not_null",
        "is_being_synced" = "false",
        "storage_medium" = "hdd",
        "storage_format" = "V2",
        "inverted_index_storage_format" = "V1",
        "enable_unique_key_merge_on_write" = "true",
        "light_schema_change" = "true",
        "disable_auto_compaction" = "false",
        "enable_single_replica_compaction" = "false",
        "group_commit_interval_ms" = "10000",
        "group_commit_data_bytes" = "134217728",
        "enable_mow_light_delete" = "false"
        );
    """

    sql """ insert into ${table1} (pk,col_boolean_undef_signed,col_boolean_undef_signed_not_null,col_tinyint_undef_signed,col_tinyint_undef_signed_index_inverted,col_tinyint_undef_signed_not_null,col_tinyint_undef_signed_not_null_index_inverted,col_smallint_undef_signed,col_smallint_undef_signed_index_inverted,col_smallint_undef_signed_not_null,col_smallint_undef_signed_not_null_index_inverted,col_int_undef_signed,col_int_undef_signed_index_inverted,col_int_undef_signed_not_null,col_int_undef_signed_not_null_index_inverted,col_bigint_undef_signed,col_bigint_undef_signed_index_inverted,col_bigint_undef_signed_not_null,col_bigint_undef_signed_not_null_index_inverted,col_decimal_16__8__undef_signed,col_decimal_16__8__undef_signed_index_inverted,col_decimal_16__8__undef_signed_not_null,col_decimal_16__8__undef_signed_not_null_index_inverted,col_decimal_38__9__undef_signed,col_decimal_38__9__undef_signed_index_inverted,col_decimal_38__9__undef_signed_not_null,col_decimal_38__9__undef_signed_not_null_index_inverted,col_decimal_38__30__undef_signed,col_decimal_38__30__undef_signed_index_inverted,col_decimal_38__30__undef_signed_not_null,col_decimal_38__30__undef_signed_not_null_index_inverted,col_date_undef_signed,col_date_undef_signed_index_inverted,col_date_undef_signed_not_null,col_date_undef_signed_not_null_index_inverted,col_datetime_undef_signed,col_datetime_undef_signed_index_inverted,col_datetime_undef_signed_not_null,col_datetime_undef_signed_not_null_index_inverted,col_datetime_3__undef_signed,col_datetime_3__undef_signed_index_inverted,col_datetime_3__undef_signed_not_null,col_datetime_3__undef_signed_not_null_index_inverted,col_datetime_6__undef_signed,col_datetime_6__undef_signed_index_inverted,col_datetime_6__undef_signed_not_null,col_datetime_6__undef_signed_not_null_index_inverted,col_char_255__undef_signed,col_char_255__undef_signed_index_inverted,col_char_255__undef_signed_index_inverted_p_e,col_char_255__undef_signed_index_inverted_p_u,col_char_255__undef_signed_not_null,col_char_255__undef_signed_not_null_index_inverted,col_char_255__undef_signed_not_null_index_inverted_p_e,col_char_255__undef_signed_not_null_index_inverted_p_u,col_varchar_1024__undef_signed,col_varchar_1024__undef_signed_index_inverted,col_varchar_1024__undef_signed_index_inverted_p_e,col_varchar_1024__undef_signed_index_inverted_p_u,col_varchar_1024__undef_signed_not_null,col_varchar_1024__undef_signed_not_null_index_inverted,col_varchar_1024__undef_signed_not_null_index_inverted_p_e,col_varchar_1024__undef_signed_not_null_index_inverted_p_u) values (0,false,true,6,0,7,51,29147,-19092,-32768,6792,1778213013,-1435420605,1141000263,-1534880882,1,1761809579,-1473846718,-2143986798613836525,2.1826,94.0496,75.0156,1.2,100.02,-1.2,85.1618,97.1213,13.0623,300.343,0,40.123,'2014-08-12','2014-08-12','2023-12-17','2025-02-17','2023-12-10','2023-12-10','9999-12-31 23:59:59','2027-01-16','2026-01-18','2026-02-18','2024-01-31','2024-07-01','2014-08-12','2024-02-18','2024-02-18','2024-02-18','-','why of were it''s have I''m see think on','出点这块姑娘第三方鑫辉挺多','then','--','f','i','','g','安信大品牌发过交叉口新鑫','for think at there they go','鹏飞看不到一般怎么着要时间涵盖盈盈参与本公司','do from','--','','?'),(1,false,false,-128,113,-128,1,10465,32767,3556,1,1139528841,-761314133,1337778604,1785698292,1,245,-9223372036854775808,1,-1.2,76.0528,1.2,67.0592,99.0425,0,93.1380,30.1582,47.0769,28.1861,68.1682,0,'2023-12-11','9999-12-31 23:59:59','2027-01-09','2023-12-15','2026-01-18','2025-06-18','2025-06-18','2024-01-17','2025-02-17','2024-01-09','2024-06-30 12:01:02.123','2023-12-14','2024-08-03 13:08:30','9999-12-31 23:59:59','9999-12-31','2023-12-10','调价','think no me would hey go he','--','准确量大济南收集奥运双机备份本来每一小时','不对战友','with with there get can''t that there are didn''t','have something why did','?','平志伟','双核','or or got okay i','--','and','v','','how'),(2,true,true,0,5,127,24,0,0,1,0,32679,1204712334,131128710,-48188984,4030719286291807454,245,1118154,245,100.02,300.343,0,0,1.2,67.1318,-1.2,40.123,87.0332,40.123,0,-1.2,'9999-12-31','2024-08-03 13:08:30','2023-12-18','2023-12-11','2023-12-20','2023-12-14','2026-02-18','2023-01-15 08:32:59.123123','2024-02-18','2023-12-18','2024-01-09','2024-01-09','2026-02-18','2023-12-13','2023-01-15 08:32:59.123123','2023-12-17','oh','no','歉意一万瑞丽首创楼下有带你呢里我们的','实际','助理不来更好调货贰仟天孝上次三星信息开始','盘点倪玲梅通过之间在欧普甘心史丽价格中层班','','w','-',null,'-','you''re been a just want','--','--','you''re think have then here your back want okay he','to'),(3,null,false,-116,2,-10,-128,0,-19330,-1,-32768,32679,32679,1794711563,147483648,9223372036854775807,-5976144,5093058139963235597,-1,null,-1.2,1.2,300.343,null,100.0436,68.0178,40.123,0,1.2,1.2,1.2,'2025-06-18','2024-06-30 12:01:02.123','2024-02-18','2024-01-09','2023-12-15','2025-02-17','2023-12-09','2024-02-18','9999-12-31','2023-12-17','2023-12-11','2024-07-01','2023-01-15 08:32:59.123123','2023-12-12','2023-12-17','2023-12-11','写上去多少钱金牌',null,'k','r','大棒','-','-','?',null,'come','w','--','妈的','will she a back it your no we right','it time','都想发生过网友真实日常厂家电脑上一周品放哥们'),(4,false,false,127,-1,-79,0,-17185,2004,23010,22407,-1,-632380417,1,2147483647,3382316,-7240048716014761707,-9223372036854775808,0,68.0355,100.02,-1.2,100.02,14.1965,93.1440,100.02,15.0576,1.2,1.2,22.1645,300.343,'2025-06-18','2024-02-18','2026-01-18','9999-12-31 23:59:59','2014-08-12','9999-12-31','2014-08-12','2023-12-15','9999-12-31 23:59:59','9999-12-31','9999-12-31','2027-01-09','2027-01-09','2026-02-18','2024-02-18','2023-12-19','太不','幸福','so say with it''s some you''re was back with','--','we','-','didn''t hey see up tell he or you''re','r','of mean like me right to','-','-','?','didn''t really or you','-','?','-'),(5,true,false,-61,-128,-1,0,24747,245,-32768,245,147483648,2147483647,493846618,2147483647,0,32679,245,-4340674386294581762,null,30.0155,300.343,0,300.343,100.02,93.0143,300.343,0,0,40.123,100.02,'2023-12-20','2023-12-13','2024-08-03 13:08:30','2026-01-18','2024-01-09','2023-12-15','2023-12-12','2024-02-18','2023-12-14','2027-01-16','2023-12-19','9999-12-31 23:59:59','2023-12-18','2024-01-31','2026-01-18','2023-12-15','','也会做成你杀时间天马回首研修网零捌鑫辉导入付出过','j','--','港湾潇湘谈好擅作主张景峰签订政策就像海域哦留一下','--','d','not going have some if out','-','忙碌','小灵通散落的小孩实业以为做梦他人调整扩展板说吧','就行','if','集团今收到工作轻信纽曼词典何时基本上','美丽回答问题','--'),(6,false,false,-1,127,1,-76,26368,245,-20769,-31761,0,-87885460,-1652669168,1684034981,0,null,8357353231250405620,-1,100.02,40.123,-1.2,29.1360,71.1085,300.343,21.0104,67.0505,-1.2,96.1324,0,-1.2,'2024-02-18','2024-01-31','2014-08-12','2023-12-12','2025-06-18','9999-12-31','2023-12-16','2023-12-13','2023-12-15','2025-02-18','2023-12-10','2024-01-09','2025-06-18','2023-12-18','2024-01-08','2014-08-12','光电','核对过',null,'--','国泰驱动器送去标志讲的服务站最好王平表格这段','in','q','投影机没有提到货差不多导轨张小莉用友有事情高端','新版原则经过','now','?','who really do me','-','didn''t','小玲','her'),(7,null,false,-1,-128,-128,-107,-31316,-32768,-32768,-32768,-138120024,147483648,2147483647,1335988149,-9223372036854775808,1,-6565982757735791562,6282666766883208310,1.2,-1.2,1.2,-1.2,null,40.123,4.1068,15.1504,92.0723,100.02,-1.2,99.0991,'2026-01-18','9999-12-31 23:59:59','2024-07-01','2025-02-17','2026-02-18','9999-12-31 23:59:59','2023-12-12','2023-12-19','2025-06-18','2024-01-19','2023-12-13','2024-02-18','2023-12-10','2023-01-15 08:32:59.123123','2026-01-18','2024-02-18','to a was no do','加入一辈子春子附件欢迎欢迎小精灵','go yeah now they when time','要时间楚留香飞信等级第一端口小时交到去年宝莱','hey','-','?','?','一些','him','手续金总淀雪集成','建新低端身边很好用讲师一脚转账濮阳单挑新鑫','办法差点孙瑞霞真人','周保全','那款可是','?'),(8,true,true,null,1,-50,1,-32768,25936,-1886,-29490,1,-2041458557,-2147483648,1987274488,228059854974871232,1757886170,1,245,100.02,30.0503,300.343,51.1272,1.2,-1.2,11.1134,0,-1.2,46.0419,32.0499,40.123,'2014-08-12','2024-02-18','2024-02-18','2023-12-09','2024-08-03 13:08:30','2027-01-16','2024-08-03 13:08:30','2023-12-10','2024-06-30 12:01:02.123','2024-01-19','2025-02-18','2007-09-04','9999-12-31 23:59:59','2024-01-09','2023-01-15 08:32:59.123123','2024-06-30 12:01:02.123','?','还好吧转移分钟旅之星成本条件原厂核算','走走道理一级周期','老是','he''s','百家重点简单好人坏人经历过是哦正式版条件威达','--','电话本',null,'k','--','did','-','男人','hey hey can out','t'),(9,false,true,0,-1,1,127,245,-32768,9807,32767,-1329389605,null,-2147483648,-1299351057,32679,1245554360,-1,147483648,88.0140,100.02,57.1036,26.1340,40.123,41.0937,73.1899,50.1680,72.0478,0,96.0750,-1.2,'2024-06-30 12:01:02.123','2025-06-18','2026-01-18','2024-07-01','2023-12-13','2024-08-03 13:08:30','2023-12-14','2023-12-20','2023-12-14','9999-12-31','2024-02-18','2023-01-15 08:32:59.123123','2024-06-30 12:01:02.123','2024-01-31','2023-12-11','2023-12-10','say','her','?','had i from look with didn''t look I''m','how','-','g','one it''s I''ll if it''s','吃过饭不让所作创恒还记得','可怕哈哈有钱老公不错总业绩歉意儿时瑞昌','u','?','华骏机器喜欢通过','don''t well as because well do time look good','西开发洗液失陪张经理老大赶紧有你们检查','水晶'),(10,false,true,null,-128,0,-128,14546,22850,20525,24943,-1,32679,1508441540,875534091,9223372036854775807,null,-2758791448581148818,6975488372886115484,17.0341,0,-1.2,300.343,9.1815,null,0,-1.2,87.0250,null,300.343,15.0047,'2024-01-09','2023-12-13','2024-01-19','2025-06-18','2023-12-17','2023-12-13','2023-12-20','2023-12-17','2024-07-01','2024-08-03 13:08:30','2027-01-16','2025-06-18','2024-02-18','2023-12-09','2011-01-13','2024-01-09','how','正联','',null,'那就好','如何','be','','?','a can''t is it''s','k','夜间','每天','my','why','-'),(11,false,true,70,null,8,8,-32768,null,0,-4374,2147483647,-1,438559785,2024065986,5058972017957328105,-53596719,6508809320674373367,147483648,100.02,71.1880,40.123,-1.2,63.0861,-1.2,300.343,0,100.02,1.2,-1.2,1.2,'2013-03-13','9999-12-31','2023-12-09','2024-02-18','2023-12-18','2024-06-30 12:01:02.123','2026-01-18','2023-12-15','2024-02-18','2024-06-30 12:01:02.123','2024-02-18','2023-12-11','2023-12-20','9999-12-31','2023-12-19','2023-12-18','did okay well for',null,'小心','had ok about if my','don''t of then do with some I''ll my don''t why','he did did they','这是','look','红色警戒老大清楚对话小故事发展动物全系列照面','--','right time who been time will that','好处','客户','-','美好','e'),(12,true,false,1,0,8,119,19259,21403,-14072,245,1,32679,147483648,1021379341,-9223372036854775808,-1475082893389938090,3564281329820020266,7168518253877601284,1.2,0,1.2,40.123,100.02,null,17.0702,1.2,100.02,33.1089,62.0820,-1.2,'2026-02-18','2027-01-09','2024-01-08','2024-02-18','2024-06-30 12:01:02.123','9999-12-31 23:59:59','2024-01-19','2024-06-30 12:01:02.123','2024-01-31','2024-01-17','2023-12-18','2025-02-17','2023-12-12','2023-12-14','2025-06-18','2025-06-18',null,'a','?','x','not','--','--','--','k','l','yeah','--','夜市','帮忙','唯一伏牛路不太中原北着那个家弱阳性夜市白晶','据对'),(13,true,false,127,0,127,-128,15507,10481,-1,2174,-1690405458,null,-2147483648,-595394109,9223372036854775807,1,1,-9184336785032758929,0,100.02,1.2,100.02,1.2,1.2,94.1575,25.0819,40.123,0,10.1497,1.2,'2024-02-18','2024-06-30 12:01:02.123','2023-12-14','2014-08-12','2025-02-18','2023-12-13','2001-06-13','9999-12-31 23:59:59','2025-06-18','2023-12-14','2025-06-18','2026-01-18','2023-12-18',null,'2024-02-18','2023-12-14','热线发吧','say the can mean no','--','-','at','?','--','about','from not not for to would on','--','the just with right','-','恢复感悟绿洲你用手机吧五千此外套件最起码把握','I''m mean be on well how','can','超利那位被人大棒两天一下阿良子猜到'),(14,false,false,-1,1,-1,-91,-406,-1,11862,13093,-1199392688,147483648,2147483647,-1392465743,9223372036854775807,-7375613,-1,-9223372036854775808,null,null,300.343,9.1615,null,0,97.0280,-1.2,24.0103,-1.2,0,100.02,'2024-01-08','2025-02-17','2018-12-12','2027-01-16','2023-12-09','2024-08-03 13:08:30','2024-01-08','2023-12-09','2023-12-19','2025-02-18','2027-01-09','2024-02-18','2023-01-15 08:32:59.123123','2024-01-09','2023-12-11','2026-02-18','','有什么提高平均天数东风系列三石有点忙进出大厦','at about it didn''t me this could in at don''t','got','as know as some can all up','want for to','','had','at with that''s me been because ok','--','are','小心自信','','砖石','--','up'),(15,false,true,-66,1,0,-1,-16724,32767,32767,27388,-2147483648,2147483647,32679,-1,0,245,-8091874767926804361,-2771121,-1.2,300.343,1.2,1.2,99.0973,7.0838,40.123,0,53.1169,53.1013,100.02,52.1436,'2024-01-19','2023-12-18','2024-08-03 13:08:30','2024-06-30 12:01:02.123','2023-12-19','2023-12-17','2027-01-16','2023-12-13','9999-12-31 23:59:59','2026-02-18','2026-02-18','2026-01-18','2023-01-15 08:32:59.123123','2024-01-31','2023-12-11','9999-12-31 23:59:59','?',null,'-','来看','高科','w','日信手机号配置参数科美属于你才回来详谈好早每天信息化','-',null,null,'期盼量大优惠李经理网页信任付费性格','虚妄','your','ok there not how','签字含税诚心对不对','when'),(16,false,false,-55,-29,6,-1,-17558,-32768,-11751,1,null,32679,-1794992889,-775086467,-4726114,-7209747535756199146,1,32679,5.0462,37.0608,0,13.0183,1.2,1.2,54.1299,-1.2,84.1056,39.1453,39.0725,1.2,'2025-02-17','2023-12-16','2023-12-12','2025-02-18',null,'2025-06-18','2027-01-09','2027-01-16','2024-01-31','2014-08-12','2024-02-18','2027-01-16','2023-12-11','2023-12-19','2024-01-19','2024-01-19','-',null,'okay this','第三只人选时间','--','-','her','莱克特播放五号屏幕武侠那里刘亮沃尔普打击赞美诗','--','?','--','-','who','got been','歘俩','红色之日起'),(17,false,false,1,-128,0,1,-32768,-29436,0,32767,1810524027,582227987,-374931303,2147483647,32679,-411987,147483648,5337900138548455534,18.1431,6.1739,40.123,40.123,-1.2,40.123,1.2,1.2,48.0870,40.123,0,5.0035,'2025-06-18','2023-12-15','2023-12-16','2023-12-15','2024-02-18','2024-02-18','2025-06-18','2024-02-18','2023-12-10','9999-12-31 23:59:59','2023-12-09','2023-12-13','2024-02-18','2024-02-18','2024-01-09','2023-12-19','yeah one with but really think his would','发给一帆','do','say','-','-','?','p','帮帮','着呢','you','','-','there','that''s','-'),(18,null,true,-1,0,1,-128,null,-8330,-1,-1,-1,-1,604628330,-2147483648,245,9223372036854775807,245,-924364,46.1775,52.0705,95.0524,1.2,1.2,1.2,40.123,1.2,25.1822,0,-1.2,10.1818,'2023-12-09','2025-06-18','2027-01-16','2025-02-17','2023-12-17','2025-02-18','2024-02-18','9999-12-31 23:59:59','2024-01-31','2023-12-09','2023-12-13','2027-01-16','2024-01-19','2023-12-17','2014-08-12','2025-02-18','谢晓娟提到','didn''t no','is just would how','i want going got not','直销','w','o','the','mean tell was just you''re didn''t come I''ll now','谦虚想起来镜面证书','out ok on go know that was get so well','放弃避免着呢交流群商家交叉文字软件园孙海洋又是','is','子夜但愿地方','','这不是惊喜金牌王平站在羡慕上不了正式'),(19,true,false,127,127,127,-28,1,16316,9388,-16775,0,-1,147483648,216679344,5314322873430997249,-5223860621338077949,245,32679,0,100.02,1.2,300.343,100.02,87.1801,40.123,300.343,0,0,0,0,'2024-01-08','2024-02-18','2023-12-14','2027-01-16','2026-02-18','2024-01-31','2024-02-18','2024-01-31','2023-12-15','2025-02-18','2024-01-08','2026-02-18','2024-01-19','2024-01-09','2026-02-18','2023-12-15','','算是','现在','扩展板','-','--','about','','you''re','--','this then of at him it were','--','of the I''m','as he see is from what were this do some','',''),(20,true,false,-31,-67,18,1,-11733,1,29574,-32768,1,32679,-1,-118389404,null,-1988138342,-350036750,-9223372036854775808,41.1195,null,41.0719,60.0534,300.343,24.1464,40.123,44.1265,300.343,40.123,300.343,0,'2025-02-17','2023-12-15','9999-12-31 23:59:59','2024-01-19','2024-02-18','2023-12-18','2023-12-18','2023-12-09','2024-02-18','2023-12-15','2018-09-07','2024-02-18','2025-02-17','2023-12-11','2026-02-18','2024-01-09',null,'--','','got','?','tell good there','','?','--','is and now','--','报账','操作系统刻骨铭心汇祥想过看完当兵除外','she','','过程均为火车站着那个家王佩丽'),(21,false,true,0,-128,-128,-5,-1,1625,-1,16024,-1,null,0,0,-9223372036854775808,0,1,-5364720998564414400,42.0321,300.343,18.1915,41.1298,85.0304,55.1246,62.1369,0,20.1409,300.343,300.343,300.343,'2023-12-15',null,'2023-12-19','2025-02-17','2014-08-12','2023-12-09','9999-12-31','2027-01-09','2025-06-18','2023-12-16','2025-02-18','2023-12-19','2014-08-12','2026-02-18','2023-12-10','2027-01-09','好久不见我刚回来呀办好专业','有数','显卡','领取怎么找收索导轨','he I''m they say you from','授权书','--','-','脱机多少钱说话工程洛宁词句就行众佳科技大厦工业大学','平均','so','don''t as come','类似','?','the him we look had','郑大'),(22,null,true,-1,83,-128,127,null,1,-20459,20744,-2118077137,1727350049,1554325769,810436158,147483648,7536560694077524474,1,245,1.2,1.2,0,100.02,null,300.343,40.123,24.0147,0,0,47.1093,74.0569,'2025-06-18','2027-01-16','2023-12-19','2027-01-09','2024-01-19','2023-12-16','2026-01-18','2024-01-09','2023-12-17','2023-12-15','2024-01-31','2024-02-18','2023-12-18','2023-12-16','2027-01-16','2014-08-12','王睿我借你饱和升职','say','','很好用','','and','允许医生需方北站','just some from at he''s go yes out like got','a','注册表香港张先波开除国栋市场上杂请你们','-','--','--','-','银联','just'),(23,true,true,-100,32,45,-103,1,-4869,-4341,245,2147483647,-489224322,-2147483648,147483648,245,null,32679,-2863791432995146217,-1.2,-1.2,300.343,63.0553,300.343,0,300.343,100.02,40.123,47.0261,8.0695,1.2,'2023-12-18','2023-12-16','2027-01-16','2025-06-18','2023-12-20','2023-12-11','9999-12-31','2023-12-12','2024-01-19','2023-01-15 08:32:59.123123','2026-01-18','2024-01-19','2023-12-12','2025-02-17','2023-12-12','2025-02-17','your','--','发生过北环经销商蠢材出来','华栋','--','--','here','he''s know from see on the me so yes','--',null,'下月汉语天普','y','x','--','?','q'),(24,true,false,8,-116,-70,0,18768,-27168,-32768,32767,-2147483648,-491681230,-1,1543210001,0,-4158749369703753712,-1066924451,-5949701957015571793,1.2,-1.2,1.2,1.2,null,null,300.343,40.123,40.123,1.2,11.1427,58.0781,'2024-01-19','2025-06-18','2024-06-30 12:01:02.123','2024-02-18','2026-02-18','2027-01-16','2014-08-12','2025-06-18','2024-01-09','2023-12-10','2023-12-18','2026-02-18','2025-06-18','9999-12-31 23:59:59','2023-12-17','2023-12-12','what','j',null,'贵姓','z','-','--','about were know know his','I''m look good up this','伤感','很细那个','be is get oh his','-','','同时最深','命名零度'),(25,false,true,123,null,0,127,245,29270,18912,27671,2056423585,-1114681434,0,-1666299227,9223372036854775807,-890780121,245,-1,1.2,63.0243,92.0015,40.123,1.2,92.1741,40.123,1.2,24.1985,300.343,100.02,1.2,'2024-02-18','2023-12-19','9999-12-31 23:59:59','2026-01-18','2023-01-15 08:32:59.123123','2024-01-19','2023-12-11','2023-12-19','2024-01-17','2023-12-18','2024-01-08','2024-08-03 13:08:30','2023-12-11','2024-01-31','2025-06-18','2024-01-17','副本恢复生意佩利待定南阳路双千兆','t','',null,'赞美诗','--','五笔有缘晨晖文利比例健民压在他人晚上聊之作','--','--',null,'?','when been me at i with time','','here at','hey would can his you her know would','he''s'),(26,null,true,null,-1,1,127,-8446,-2483,32767,2058,0,2147483647,12755506,1,8798267953845829469,32679,1872198378726361569,-2942272,69.0559,47.1497,-1.2,34.1466,100.02,-1.2,51.0790,1.2,28.0065,-1.2,-1.2,76.0019,'2026-01-18','2024-02-18','2026-02-18','2023-12-18','2023-12-17','2024-01-08','2023-12-17','2024-01-09','2023-12-18','2026-01-18','2009-05-03','2024-02-18','2024-01-08','2023-12-17','2024-01-08','2026-01-18','休息南阳路上半年重命名网管中心单挑周保全合适处理一下海尔','不敢质保终究控件不定离谱神偷','不忙','want would don''t oh I''m can''t why one yes some','令我又将','冲淡湖北比如说写在小雨奖金宝贵安全','--','b','客户端','--','out','all going okay is right','will but been when it''s','okay really I''ll what she my was he''s yeah','come the been could he''s','苦楚'),(27,null,false,null,-118,0,2,32767,-32389,30491,32101,-2147483648,-1,0,32679,9223372036854775807,-6520303307884870157,245,-9223372036854775808,5.1951,0,-1.2,40.123,86.0859,100.02,4.1986,40.123,-1.2,null,0,-1.2,'2023-12-17','2023-12-13','2025-02-18','2023-12-16','2023-12-18','2023-12-11','2014-08-12','2023-12-16',null,'2025-06-18','2023-12-09','2023-01-15 08:32:59.123123','2023-12-15','2025-02-17','2024-01-17','2023-01-15 08:32:59.123123','-','were oh from it''s right then','--','will go some my it''s going he''s','项目','o','','刘伟','he hey have just','纵观','got that ok good your be','','be','for','--','don''t really that all yeah here him for'),(28,true,true,0,63,127,127,28111,245,-29617,-4889,-1758349040,1763950935,1094280556,-637872619,-8641813557597328333,-9223372036854775808,6086990696662277493,-9223372036854775808,null,0,93.0920,1.2,null,59.1122,28.1426,49.1276,98.1143,0.0503,300.343,0,'2024-08-03 13:08:30','2024-01-19','2024-02-18','2027-01-09','2023-12-13','2024-06-30 12:01:02.123','2024-01-31','2023-12-14','2023-12-15','2025-02-18','2023-12-13','2023-12-15',null,'2025-02-17','2027-01-16','2023-12-18','阶段最近忙什么呢嵩山仔细我们的地方那个胶片厂','?','x','want','?','','on could tell in going good at know just here','-','p','冰河','could going do there could something why why you''re','have','it','k','time','--'),(29,true,false,24,127,-45,-35,0,26516,17765,20156,-1,-2046773551,1123817283,-2147483648,null,9223372036854775807,-9223372036854775808,554792133,32.0173,57.1898,300.343,300.343,10.0337,1.2,99.1261,100.02,null,40.123,93.0990,300.343,'2023-12-09','2023-12-18','2027-01-16','2023-12-19','2004-03-18','2023-12-10','2023-01-15 08:32:59.123123','2024-02-18','2023-12-10','2023-12-14','9999-12-31 23:59:59','2023-12-09',null,'2023-01-15 08:32:59.123123','2023-12-14','2024-07-01','','her go',null,'做出搞定相符宠物平均管理员排列天晴城市','每天','-','?','-',null,'多多重复岂能系统长时间保险也不是不到位','n','切换起床采用干嘛被激怒个总经销商','','--','would','名家'),(30,true,false,91,-20,15,-1,-1586,-20360,-1,31476,2147483647,1460097326,-2147483648,1,-30361165468551680,null,9223372036854775807,3259165989020601252,40.123,100.02,11.1911,93.0047,40.123,40.123,0,60.0210,1.2,10.0283,0,300.343,'2023-12-16','2023-12-12','2024-06-30 12:01:02.123','2023-12-16','2023-12-14','2024-08-03 13:08:30','2024-08-03 13:08:30','2024-01-08','2024-02-18','2024-07-01','2024-01-09','2025-06-18','2024-01-31','2023-01-15 08:32:59.123123','2025-02-18','2024-02-18','back','-','哭泣差距很大下个','z','所提供热销词库使人所有开头武警总队这话','right I''m could would','换一家','没变为你汉威政府指定昨晚上','网吧之夜不对战友小刘','from have know know',null,'?','?','--','?','高压后天回正式端口天地外聘文件核对'),(31,true,false,88,87,104,8,-32768,-20115,0,-20740,-2147483648,-2147483648,-1986116363,1,-268648447394379111,-9223372036854775808,147483648,245,-1.2,null,-1.2,27.1371,0,1.2,100.02,-1.2,null,5.1450,92.0735,1.2,'9999-12-31','2027-01-09','9999-12-31','2025-06-18','9999-12-31 23:59:59','2000-10-20','2014-08-12','2024-02-18','2023-12-11','2024-01-17','2024-02-18','2025-06-18','2023-12-19','2023-12-10','2023-12-13','2024-07-01','time','卢海一两阶段','have','think','you''re good have will do but his be','all','架子','yeah','--','--','这其中','供货明天找我贸易通背书网站必须','中小王丽','m','--','--'),(32,true,false,0,0,-1,-1,0,1,18891,0,32679,null,-2147483648,1,245,-730000963801070405,-6567954926160409570,0,300.343,21.0915,56.0350,18.0963,94.1440,1.2,53.0729,300.343,300.343,1.2,1.2,77.1375,'2027-01-16','2023-12-14','2024-01-09','9999-12-31 23:59:59','2026-01-18','2023-12-16','2024-01-17','2024-02-18','2027-01-09','2023-12-14','2023-12-17','2024-01-08','2023-12-20','2014-08-12','2023-12-09','2014-08-12','on in if you''re from','','ok your want say with hey when how there him','润泽流明次要','你好呀待定插拔日信市场目标家里','k','?','I''ll','百元整冯向百脑汇进入了付出了领先之后众诚','?','--','不曾名杂到来一共','主演王青最低汇众想到相约询问过高高','can been like come','','how about have think when but don''t the in'),(33,null,true,-1,1,22,36,-8395,-1,32767,19251,147483648,null,32679,-1194428859,null,-7003800,-1780700346672999405,32679,null,-1.2,79.0172,62.1674,1.2,37.1430,0,43.1177,300.343,300.343,100.02,2.1459,'2023-12-12','2024-01-09','2024-08-03 13:08:30','2024-01-08','2023-12-15','2023-01-15 08:32:59.123123','2026-02-18','2026-02-18','2023-12-13','2023-01-15 08:32:59.123123','2025-06-18','2026-01-18','2027-01-09','2023-12-12','9999-12-31 23:59:59','2025-02-18','--','--','look be time been back','can my like the the could her about yes got','?','七匹狼正品图标不至于','could could you a of','而来倒是佳成如果','还不错十分我能电视规定靠前客运量空分','--','回访','下个礼拜新山钻石金牌周围','-','to','-',''),(34,null,true,-128,-1,127,9,4929,-1,-32768,-1,-926729021,-489011328,2147483647,-1568695661,-5240172516187475029,1691038444,9223372036854775807,147483648,0,40.123,0,40.123,40.123,74.0504,80.0530,100.02,40.123,40.123,97.1562,100.02,'2025-06-18','2024-01-09','2024-08-03 13:08:30','2023-12-11','2023-12-11','2025-06-18','2024-02-18','2023-12-11','2024-08-03 13:08:30','2023-12-12','2024-01-08','2023-12-11','2025-06-18','2024-02-18','9999-12-31','2023-12-11','贸易通','第二款指出来数哟两千最美丽中旬','her','-','?','g','he''s tell have from good hey from is for be','it''s would really a in me who do','未定','-','okay','yeah','q','--','--','--'),(35,false,false,-79,0,-1,5,-796,17301,-22121,1,-1,1,893775863,-915924689,-4394973541698078775,-9223372036854775808,-9223372036854775808,-6550281778227888053,300.343,100.02,300.343,1.2,-1.2,1.2,77.0924,49.1457,40.123,80.0551,94.0464,52.1076,'2023-12-09','2023-12-11','2025-02-18','2023-12-18','2024-02-18','2024-08-03 13:08:30','2023-12-09','2023-12-19','2024-06-30 12:01:02.123','2014-08-12','2026-01-18','2024-01-19','2023-12-09','2023-12-09','2024-01-17','2024-01-19','这首宇瑞回答看重参与','-','明天找我','x','been have could she how at or out','--','小浪底不走客运','out don''t','亚太科美天讯同辉圣荣濑尿虾真伪黑色好梦供应商','the','some will come this be all','反应东方','-','if get','新款原创','?'),(36,true,false,3,48,-1,-48,-32768,null,-10021,28424,null,89804126,147483648,-680806434,7291697225388406934,null,-8799855892443545049,0,0,78.1267,0,-1.2,40.123,0,8.1201,100.02,1.2,1.2,100.02,100.02,'2027-01-16','2023-12-12','2023-12-19','2024-06-30 12:01:02.123','2023-12-20','2024-01-19','2023-12-16','2025-02-18','2023-12-17','2023-12-17','2024-07-01','2024-08-03 13:08:30','2023-12-15','2024-01-08','2014-08-12','2027-01-16','?','-','?','?','what','市场上天威龙弄个均为原来见过代玉对于双核','look mean my he i with hey if do but','got here we we that''s about and had him think','本公司贸易通维修你吃法除外快递','天下身份人参都有资金客服','称呼治疗我同学结婚来庆祝热播方案','一条','--','q','武汉','?'),(37,null,true,-99,127,0,-17,1,7196,31215,245,null,1008519661,-194086066,2147483647,6382203,8511043665503645950,-1,72547424616057298,-1.2,100.02,97.1904,81.0776,25.0611,33.1374,37.0332,79.1107,45.0366,-1.2,42.1639,-1.2,'9999-12-31','2023-12-12','2025-06-18','2023-12-09','2023-12-14','2023-01-15 08:32:59.123123','2024-06-30 12:01:02.123','2025-06-18','2026-02-18','2024-06-30 12:01:02.123','2024-01-09','2023-12-17','2023-12-09','2023-12-14','2024-01-08','2024-01-17','身边','?','h','--','with','ok mean back you one will will say look','红颜','then','财务部','?','her',null,'the one','','订单批发见你条数单个浪费通道看着办分销商','here'),(38,false,true,-40,127,1,93,14085,-27042,7816,9260,-1433718766,1,-1,2147483647,1,9223372036854775807,147483648,-743258780,1.2,0,40.123,100.02,81.0898,-1.2,300.343,0,1.2,40.123,300.343,100.02,'2023-12-18','2024-01-08','2023-12-11','2026-01-18','2023-12-14','2025-06-18','2024-07-01','2026-02-18','2023-12-12','2024-01-09','2024-02-18','2023-12-12','2027-01-09','2024-01-09','2024-01-31','2023-12-09','oh','惊喜金牌','m','-','oh right with me your','so him because','','x','-','-','往年','?','for','-','带你如有写上去航海路检查陈老师说不出','不下'),(39,null,true,-1,1,9,123,-30872,5079,245,-24514,1157197029,1537312088,-1,-1,890351490,9223372036854775807,-9223372036854775808,808960386243577672,1.2,0,1.2,43.0001,29.0832,30.1560,-1.2,1.2,100.02,40.123,38.1235,3.0080,'2024-06-30 12:01:02.123','2025-02-18','2025-02-18','2023-12-13','2027-01-16','2024-02-18','9999-12-31 23:59:59','2024-02-18',null,'2024-01-17','2023-12-09','2024-01-17','2023-12-13','2024-07-01','2023-01-15 08:32:59.123123','2023-01-15 08:32:59.123123','贰台','what now','-','广告','一份子','your now to see it at','不传不多记录欧洲中天的风格看课件素材量大','if is were why she that''s some say is','who from tell something','ok','技术员数码港新增大雪怡海提供开公司老总','have can''t with is oh just just','','one you''re got what you''re','自学良子除非不便欧典况且信阳卓兴据对相信','帐号'),(40,null,false,127,-1,-1,-17,-26354,-2911,32767,32767,32679,2147483647,0,2147483647,1,-9223372036854775808,0,1814090464,100.02,null,0,90.1065,100.02,-1.2,31.1376,100.02,50.0038,23.0768,-1.2,40.123,'2024-01-08','2024-02-18','2026-01-18','2026-02-18','2025-02-17','2024-02-18','2024-01-09','2023-12-11',null,'2023-12-19','2027-01-09','2025-06-18','2023-12-10','2025-06-18','2024-01-31','2023-12-19','--','兼容金达研修网小徐伟泽光电查过具体还有你的','收到云鹏增票武汉许愿树七匹狼订票改动键盘',null,'or with really they go ok say look time yes','','?','里有',null,'免费','打给','going that','删除','?','福利杨宗容量卓兴一键还原小雪','调试部分发吧李平这一块很低哪里'),(41,false,false,38,127,1,3,1,32767,-535,-25017,-1,-335834102,147483648,-2147483648,6196352782692926078,-7069508575514069654,-9223372036854775808,0,40.123,42.1813,300.343,1.2,40.123,null,70.0479,-1.2,71.1975,18.0217,1.2,1.2,'2025-02-17','2025-02-18','2024-02-18','2024-01-19','2023-12-09','2023-12-17','2027-01-09','2024-01-17','2024-08-03 13:08:30','2023-12-13','2024-06-30 12:01:02.123','2024-01-09','2023-12-13','2023-12-15','2023-12-17','2023-12-16','打扰焦煤无限烟厂不在哦传美完美','--','空下五星兄弟','则很难','-','','-','good','-','还在怎么找也会车费火车','think with oh your him','--','in','and do time','?','didn''t'),(42,null,false,null,null,-72,7,23137,-16658,-1,15469,-981817977,null,-884475713,0,9223372036854775807,0,147483648,2747189507179247531,1.2,100.02,1.2,0.1455,40.123,-1.2,54.1343,300.343,1.2,300.343,100.02,14.0976,'2023-12-16','2025-02-18','2024-01-08','2023-12-17',null,'2024-01-17','2024-08-03 13:08:30','2025-06-18','2023-01-15 08:32:59.123123','2023-01-15 08:32:59.123123','2026-02-18','2024-01-17','2026-02-18','2027-01-16','2024-07-01','2023-12-14','提到个月坐在','yeah','小时','一舟','--','?','your','k','on',null,'提出春节停产散落的','-','两个','不需要','say as don''t can','think do when don''t got some okay no back there'),(43,null,false,127,-1,126,-21,245,-8884,17360,-32768,1,0,1,166489221,147483648,245,9223372036854775807,-1,79.0906,-1.2,40.123,40.123,100.02,0,1.2,0,-1.2,40.123,21.1863,10.1618,'2026-02-18','2027-01-09','2025-02-17','2023-12-13',null,'2024-07-01','2024-08-03 13:08:30','2005-07-16','2023-12-16','2014-08-12','2024-01-08','2023-12-13','2024-02-18','2027-01-09','2024-07-01','2023-12-20','?',null,null,'-','she','n','参观都想小灵通干嘛信海太厚埋在合创','--','is from not been I''m good did be','称呼','-','','他妈也好湖北美丽不对跑跑卡丁车说出来一张','赵芳','did','高高'),(44,null,true,1,48,8,0,-30056,1,26163,0,292275484,32679,-1574338139,-786277339,-1,245,3690369133288045380,2739405,24.1123,2.1873,300.343,0,-1.2,0,40.123,43.0193,29.0534,1.2,51.1334,40.123,'2014-08-12','2024-01-09','2024-01-08','2024-02-18','2025-06-18','2024-08-03 13:08:30','2024-01-08','2024-02-18','2023-12-16','2023-01-15 08:32:59.123123','2024-02-18','2023-12-15','2025-06-18','9999-12-31','2026-02-18','2027-01-16','','你家哦跟你说',null,'about when one','-','ok a so he''s to','that''s a him out yes would','are a how and at are a','-','面子饲料询问过建议政府性价比系统集成商','what','p','go','who this just is oh know would did that''s','','海川'),(45,true,false,63,0,127,-123,1,null,0,28568,1596508631,-2147483648,2147483647,1157679284,1,9223372036854775807,-7259578370457002861,-204357924,0,100.02,100.02,1.2,1.2,88.0444,1.2,39.0709,76.1952,null,55.1933,0,'2023-12-13','2024-01-08','2023-12-18','2023-12-19','2025-06-18','2023-12-10','2023-12-16','2024-01-17','2024-08-03 13:08:30','2025-06-18','2023-12-11','2023-12-19','9999-12-31','2023-12-14','2016-11-15','2023-12-16','能早点组装方连一流','-','的那个','y','可惜','?','叫做','p','待定',null,'say','伤和气','--','that''s to want oh just is','-','got'),(46,false,true,0,102,6,127,null,24574,32767,32767,415649751,-2147483648,1465783352,1,245,-4275036788457434117,1,32679,null,52.1149,-1.2,1.2,0,0,87.0916,-1.2,39.1247,4.0706,-1.2,-1.2,'2024-01-08','2023-12-12','2023-12-15','2025-02-18','2006-04-04','2027-01-09','2014-08-12','2023-12-20','2025-06-18','2026-02-18','2023-12-10','2024-06-30 12:01:02.123','2024-08-03 13:08:30','2026-02-18','2023-01-15 08:32:59.123123','2024-07-01','-','两者','调货忘记销售资格首位批复已给李景林想不到','go','why come','then if we know you''re you not tell because yeah','双子','b','但是增票浩宇地图分辨率几篇防火墙','?','when','o','总结浇水','羡慕','-','?'),(47,null,false,1,-1,1,-74,32767,-5076,2338,-27143,0,124418066,2147483647,1381223492,-1937424844986983939,147483648,-1,1,1.2,95.1064,0,58.0528,40.123,null,0,81.1194,40.123,100.02,30.0961,40.123,'2024-02-18','2024-07-01','2024-02-18','2023-12-10','2023-12-11','2023-12-15','2026-02-18','2023-12-20','2025-02-18','2024-01-08','2025-02-18','2023-12-17','2027-01-16','2023-12-14','2001-07-19','2025-06-18','补丁提到','one','岩春服务器站胡华威计划认识你不信吗','k','刘海下一部分名字中晶月份意义郑州可靠','-','-','','she','能不鞥','like','惊喜总代理商','小型机','but about were the because you','his','look'),(48,true,true,1,0,-1,1,-32768,-32768,-6624,245,32679,2147483647,1111644729,1,147483648,null,147483648,-9061497079404703305,98.1875,38.0903,67.1236,0,4.1641,17.0363,-1.2,10.1437,7.0136,8.1929,35.1616,0,'2024-01-19','2026-02-18','2023-12-18','2027-01-09','2023-01-15 08:32:59.123123','2024-01-31','2024-01-19','2024-01-09','2023-12-10','2024-07-01','2024-01-08','2025-02-17','2023-01-15 08:32:59.123123','2017-10-02','2024-02-18','2024-06-30 12:01:02.123','这不是有项目列表底下煤气前提报账','could him was well really up have see well really','台式机','-','卢海认为不至于医院许愿树河南总代理资质报表','','-','go don''t him yes well as like','说好耀博请重试场景许文及其长期不了一套帐期','名次','写上掏点钱弟子看不出来问过谁知道星星西郊价格','','真正','切换期盼','something there then did if but it''s','?'),(49,false,false,-1,0,81,3,32767,12315,-1,-18884,-1105820371,1,787531014,1603914739,0,32679,1347350265,-1,72.1999,40.123,1.2,-1.2,-1.2,1.2,1.2,1.2,45.0509,94.0948,0,30.1775,'2024-01-19','2024-01-31','2024-01-08','9999-12-31 23:59:59','2024-07-01','2023-12-10','2023-12-15','2023-12-17','2026-02-18',null,'2023-01-15 08:32:59.123123','2024-08-03 13:08:30','2023-12-13','2024-08-03 13:08:30','2026-02-18','2023-12-09','for','-','there','-','y','s','一家','','港湾样品礼拜天没变心连心氛围收藏夹亮度医药上机柜','-','利达汉化补丁也好什么塔式','go want time been there one how is','would','-','短信一开打工的比人韩鸽飞中龙快运郑东排列开机','停产'),(50,null,true,0,1,0,-128,32767,-1,245,245,null,-1,147483648,2147483647,147483648,null,-1,1,40.123,99.0784,1.2,50.1917,56.0902,40.123,57.0612,80.1629,0,0,37.1425,-1.2,'2023-12-16',null,'2024-01-17','2023-12-19','2026-01-18','2027-01-16','2024-06-30 12:01:02.123','2023-12-16','2024-06-30 12:01:02.123','2026-01-18','2024-01-08','2024-01-08','2026-01-18','2026-01-18','2023-12-18','2023-12-13','词库考核列表想不到','?','that''s','can''t','how','-','--','改写太不燕龙','','right','权威','-','','沐浴群殴没错速度黄委会白经理真人青春华栋','?','see'),(51,false,true,7,-1,127,127,null,-28014,21619,-29062,32679,-453263646,1,-571902945,null,8776264616826296648,255479746459051394,1,100.02,300.343,1.2,100.02,0,-1.2,18.0864,0,40.123,300.343,1.2,40.123,'2023-12-10','2015-11-19','2016-10-25','2023-12-13','2024-08-03 13:08:30','9999-12-31 23:59:59','2025-02-18','2023-01-15 08:32:59.123123','2023-12-13','2023-12-13','2014-08-12','2023-12-17','2024-02-18','2027-01-16','2024-02-18','2024-07-01',null,'--','or','been','w','l','杨宗','辅佐','with they one yes yes don''t some why for here','不见拜托才好见过面令我','礼物限价再发白菜不定拿货青青绿色称呼志彬彭伟','一周','文杰很难原厂做到','--','I''ll not you your the your tell he okay','我在政治哦配合雅鹿沙及其办公考虑神秘面对'),(52,true,false,30,-68,11,127,-32768,-30696,245,1,-89768634,871771752,874669061,1683077888,null,-9223372036854775808,-1,-9223372036854775808,94.0219,40.123,1.2,100.02,0,-1.2,57.1140,0,40.123,40.123,40.123,100.02,'2023-12-18','2024-02-18','2023-12-18','2026-02-18','2023-12-11','2023-12-16','2023-12-13','2024-01-08','2023-12-20','2024-06-30 12:01:02.123','9999-12-31 23:59:59','9999-12-31','2024-06-30 12:01:02.123','2023-12-09','2023-12-11','2024-07-01','聊聊伟博普通天下无贼我们见不了吉林依然订货解决','this',null,'can''t','?','because','-','she ok then don''t like that''s we some see','-','推磨刘总出面','i','g','帮忙好处虚妄是吗过的','?','?','--') """

    qt_sql """
        SELECT count(col_decimal_16__8__undef_signed_index_inverted) FROM ${table1} where col_decimal_16__8__undef_signed_index_inverted is null;
    """
    

}
